;
; This is the assembler include file that belongs to mikmod.lib
;
; Created Sun 2nd July 1995 by MikMak / Jean-Paul Mikkers
;

EF_ON               EQU     1
EF_SUSTAIN          EQU     2
EF_LOOP             EQU     4

UF_XMPERIODS        EQU     1
UF_LINEAR           EQU     2


; MMIO.C

GLOBAL C            _mm_open            :FAR
GLOBAL C            _mm_close           :FAR
GLOBAL C            _mm_read            :FAR
GLOBAL C            _mm_lseek           :FAR
GLOBAL C            _mm_malloc          :FAR
GLOBAL C            _mm_realloc         :FAR
GLOBAL C            _mm_free            :FAR
GLOBAL C            _mm_calloc          :FAR
GLOBAL C            _mm_memset          :FAR
GLOBAL C            _mm_memcpy          :FAR
GLOBAL C            _mm_memcmp          :FAR
GLOBAL C            _mm_setvect         :FAR
GLOBAL C            _mm_getvect         :FAR
GLOBAL C            _mm_getenv          :FAR
GLOBAL C            _mm_strtol          :FAR
GLOBAL C            _mm_outstring       :FAR

; MERROR.C:

GLOBAL C            myerr               :FAR PTR BYTE


; MDRIVER.C:

DMODE_STEREO        EQU     1
DMODE_16BITS        EQU     2

SF_16BITS           EQU     1
SF_SIGNED           EQU     4
SF_LOOP             EQU     8
SF_BIDI             EQU     16
SF_DELTA            EQU     32
SF_OWNPAN           EQU     64

GLOBAL C            md_device           :WORD
GLOBAL C            md_mixfreq          :WORD
GLOBAL C            md_dmabufsize       :WORD
GLOBAL C            md_mode             :WORD
GLOBAL C            md_numchn           :BYTE

GLOBAL C            MD_InfoDriver       :FAR
GLOBAL C            MD_RegisterDriver   :FAR
GLOBAL C            MD_SampleLoad       :FAR
GLOBAL C            MD_SampleUnLoad     :FAR
GLOBAL C            MD_Init             :FAR
GLOBAL C            MD_Exit             :FAR
GLOBAL C            MD_PlayStart        :FAR
GLOBAL C            MD_PlayStop         :FAR
GLOBAL C            MD_Update           :FAR
GLOBAL C            MD_VoiceSetVolume   :FAR
GLOBAL C            MD_VoiceSetFrequency        :FAR

GLOBAL C            MD_VoiceSetPanning  :FAR
GLOBAL C            MD_VoicePlay        :FAR

GLOBAL C            SL_Init             :FAR
GLOBAL C            SL_Load             :FAR


; MLOADER.H:

GLOBAL C            ML_RegisterLoader   :FAR
GLOBAL C            ML_LoadFD           :FAR
GLOBAL C            ML_LoadFN           :FAR
GLOBAL C            ML_Free             :FAR


; MPLAYER.H:

GLOBAL C            mp_bpm              :BYTE
GLOBAL C            mp_patpos           :WORD
GLOBAL C            mp_sngpos           :WORD
GLOBAL C            mp_sngspd           :WORD
GLOBAL C            mp_loop             :WORD
GLOBAL C            mp_panning          :WORD
GLOBAL C            mp_extspd           :WORD
GLOBAL C            mp_volume           :BYTE
GLOBAL C            mp_numchn           :BYTE

GLOBAL C            MP_Ready            :FAR
GLOBAL C            MP_NextPosition     :FAR
GLOBAL C            MP_PrevPosition     :FAR
GLOBAL C            MP_HandleTick       :FAR
GLOBAL C            MP_Init             :FAR


; VTIMER.H

VT_VRSYNC           EQU     1
VT_CALLOLD          EQU     2

GLOBAL C            VT_Exit             :FAR
GLOBAL C            VT_Init             :FAR
GLOBAL C            VT_Alloc            :FAR
GLOBAL C            VT_Free             :FAR
GLOBAL C            VT_SetHandler       :FAR
GLOBAL C            VT_SetSpeed         :FAR
GLOBAL C            VT_SetBPM           :FAR
GLOBAL C            VT_Start            :FAR
GLOBAL C            VT_Stop             :FAR
GLOBAL C            VT_Mode             :FAR
GLOBAL C            VT_V0Handler        :FAR
GLOBAL C            VT_V1Handler        :FAR


; LOADERS & DRIVERS:

GLOBAL C            uniload
GLOBAL C            gusdriver
GLOBAL C            nosnddriver
